#!/bin/bash

#test if X is running,  and set DIALOG
# removed

DIALOG=Xdialog


sync

#### Find out where we are (more reliable than pwd with rox)
MYDIR=`echo $0|sed 's/[^/]*$//'|sed 's/\/$//'`

if [ "$MYDIR" = "." ]; then
  MYDIR=`pwd`
fi

#tar -xjvf "$MYDIR/tkhearts.tbz" tkhearts/resource/prepreinstall.sh
#cd "tkhearts/resource"
./prepreinstall.sh

cd "$MYDIR"


echo a
dfree=`./dfree.sh /root`
echo b

RELOC="0"
if [ -f "$MYDIR/reloc" ];then
  RELOC="1"
fi

TARGET="/usr/local"
RELOCTARGET="/usr/local"
PACKEXIST="0"

if [ -f "/root/.packages/tkhearts.files" ];then
  PACKEXIST="1"

unknown="$RELOCTARGET"
s="dotpupwizard.marker"
a=` cat "/root/.packages/Puppy-search-test.files" | grep "$s" | grep -v grep |sed -e "s/$s$//" -e "s/\/$//"`

  if [ -d "$a/tkhearts" ];then
    RELOCTARGET="$a"
    unknown="$a"
  else
    unknown="*a unknown location*"
  fi
fi




if [ "$RELOC" == "1" ];then

if [ -f /usr/sbin/partview ];then
  killall partview
  partview &
else
df -m >/tmp/dotpupdf.tmp
Xdialog --no-cancel --title "free diskspace" --textbox "/tmp/dotpupdf.tmp" 20 80 &
fi
sleep 1
echo "/usr/local" > /tmp/dotpupsavefolder.cfg
cp dir_o.xpm /tmp/dir_o.xpm
cp savefolder.sh /tmp/dotpupsavefolder.sh
cd $RELOCTARGET
"$MYDIR/dirbox.sh"
rm -f /tmp/dir_o.xpm
rm -f /tmp/dotpupsavefolder.sh
cd "$MYDIR"
TARGET=`head -n 1 /tmp/dotpupsavefolder.cfg`

  if [ "$PACKEXIST" == "1" ];then
  if [ "$RELOCTARGET" != "$TARGET" ];then
    msg="
!!! -- W A R N I N G -- !!!

You want to install
tkhearts
to

$TARGET

But it already was installed to

$unknown

You now get the choice to UN-install the old Dotpup.
You really SHOULD do that!
If you do not, your old installation will get broken, and can not be removed with PupGet anymore!

!!! -- W A R N I N G -- !!!
"
xmessage -center -buttons continue,exit "$msg"
if [ $? != 101 ];then
  exit 1
fi

  fi
  fi

    pspace=`head -n 1 size.txt`
    pspacefs=`head -n 1 sizefilesystem.txt`



./pbmkdir.pb "$TARGET"

    dfree=`./dfree.sh "$TARGET"`

echo +++++++++++++++++++++
echo $dfree
echo +++++++++++++++++++++
    if [ "$dfree" == "" ]; then

      xmessage -bg red -center "ERROR: Not enough free diskspace,
you have 0 MB on $TARGET.
Needed are $pspace!
Is $TARGET not mounted?
"
      exit 1
    fi
    if [ $dfree -lt $pspace ]; then

      xmessage -bg red -center "ERROR: Not enough free diskspace,
you have only $dfree MB on $TARGET.
Needed are $pspace!"
      exit 1
    fi

    dfree=`./dfree.sh "/root"`

echo +++++++++++++++++++++
echo $dfree
echo +++++++++++++++++++++
    if [ "$dfree" == "" ]; then

      xmessage -bg red -center "ERROR: Not enough free diskspace,
you have 0 MB on /root.
Needed are $pspacefs!
Is $TARGET not mounted?
"
      exit 1
    fi
    if [ $dfree -lt $pspacefs ]; then

      xmessage -bg red -center "ERROR: Not enough free diskspace,
you have only $dfree MB on /root.
Needed are $pspacefs!"
      exit 1
    fi

fi
rm -f /tmp/dotpupsavefolder.cfg

if [ "$RELOC" == "0" ];then

#xmessage -center test `cat size.txt` 
a=`cat size.txt`
b=`cat sizefilesystem.txt`
pspace=`./pbexeccmd.pb "print 0$a + 0$b"`

if [ $dfree -lt $pspace ]; then

  xmessage -bg red -center "ERROR: Not enough free diskspace,
you have $dfree MB, but needed are $pspace!"
  exit 1
fi
fi


if [ ! -d "$TARGET" ];then
  xmessage -bg red -center "ERROR: folder could not be created!"
  exit 1
fi

fs=`./pbexeccmd.pb "shell(\"stat -c %T -f $TARGET\")"`

if [ "$fs" == "msdos" ];then
  xmessage -bg red -center "ERROR: do not install to a Windows Vfat-drive!"
  exit 1
fi

if [ "$fs" == "ntfs" ];then
  xmessage -bg red -center "ERROR: do not install to a Windows NTFS-drive!"
  exit 1
fi

#FOLDER=~
FOLDER="$TARGET"

#### normal users (not root) just are allowed to extract to their /home
if [ "$FOLDER" != ~ ]; then
  IAM=`whoami`
  if [ "$IAM" != "root" ]; then
     $DIALOG --title "info" --msgbox "ERROR: You must be root to install tkhearts, exiting..." 10 60
      
     exit
  fi
fi


if [ ! -d "$FOLDER" ] ;then
  mkdir $FOLDER
fi



#### If folder exists and is empty (PCCC does not remove it), start uninstaller
ACTION=install
if [ -f "/root/.packages/tkhearts.files" ]; then

    #ACTION=`xmessage -nearmouse -print -buttons un-install,re-install "tkhearts already exists, your choice?"`

     $DIALOG --no-cancel --menu "tkhearts already exists, your choice?" 10 60 2 "1" "re-install" "2" "un-install" 2>/tmp/dpimenu.txt
     ACTION=`tail -n 1 /tmp/dpimenu.txt`
fi

echo $ACTION

#### Uninstall
if [ "$ACTION" = "2" ]; then

   if [ -f "/root/.packages/tkhearts.files" ];then
     $DIALOG  --title "info" --msgbox "starting Pup-get Package-manager" 10 60
      pupget&
      exit 0
   fi

   exit 0
fi

if [ "$ACTION" = "1" ]; then
  ACTION=install
fi

if [ "$ACTION" != "install" ]; then
   exit 0
fi


#### install

##V03 #######################################################
# extract FILESYSTEM.tbz

echo -----------------
#pwd
#tar -xjvf "$MYDIR/tkhearts.tbz" tkhearts/resource/preinstall.sh
#cd "tkhearts/resource"
./preinstall.sh

cd "$FOLDER"

# first check, if files in systemfolders already exist

 rm -f  "$MYDIR/existing.txt"
 if [ -f "$MYDIR/FILESYSTEM.tbz" ] ; then
   tar -tjf "$MYDIR/FILESYSTEM.tbz" | while read a; do 

   if [ -f "/$a" ] ; then
      echo "/$a" |sed -e 's# #_#g' -e 's#^#=> #' -e 's#$##' >>  "$MYDIR/existing.txt"
   fi
   done
  fi

# check, if files in applicationfolder already exist

 if [ -f "$MYDIR/tkhearts.tbz" ] ; then
   tar -tjf "$MYDIR/tkhearts.tbz" | while read a; do 

   if [ -f "$FOLDER/$a" ] ; then
      echo "$FOLDER/$a"  | sed -e 's# #_#g' -e 's#^#=> #' -e 's#$##' >> "$MYDIR/existing.txt"
   fi
   done
  fi



 if [ -f "$MYDIR/existing.txt" ]; then
  
        FILES=`head -n 100 "$MYDIR/existing.txt"`



   $DIALOG --menu "These files already exist, overwrite them?" 20 70 14 $FILES 2>/tmp/dpimenu.txt


  if [ "$?" != "0" ];then
    $DIALOG --title "info" --msgbox "Installation canceled, exiting..." 6 60
      
    exit 0
  fi
 fi


    pspace=`head -n 1 "$MYDIR/size.txt"`
    pspacefs=`head -n 1 "$MYDIR/sizefilesystem.txt"`

cd "$MYDIR"
cat "$MYDIR/sizefilesystem.txt" > "$MYDIR/checksize.txt"

cp "$MYDIR/checkspace.pb" "$MYDIR/checkspace2.pb"

#xmessage -center "test - $pspacefs"
#if [ "$pspacefs" != "0" ];then
if [ $pspacefs -gt 4 ];then
echo MODE1
./gauge.pb "/root"&

fi

 if [ -f "$MYDIR/FILESYSTEM.tbz" ] ; then
   cd /
   tar -xjvf "$MYDIR/FILESYSTEM.tbz"
 fi


##/V03 #######################################################

cd "$MYDIR"
cat "$MYDIR/size.txt" > "$MYDIR/checksize.txt"


#if [ "$pspace" != "0" ];then
if [ $pspace -gt 4 ];then
echo MODE2
rm -f "$MYDIR/checkspace.pb"
./gauge.pb "MODE2 $FOLDER"&
fi


echo +++++++++++++
echo $FOLDER
echo "$MYDIR/tkhearts.tbz"
echo +++++++++++++

#### extract archive
  cd $FOLDER
  tar -xjvf "$MYDIR/tkhearts.tbz"

  #### were there any errors?
  if [ ! -d "$FOLDER/tkhearts" ]; then
    $DIALOG --title "info" --msgbox "Error during extraction - are you root?" 6 60
      
    exit 1
  fi

################################################
## generate symbolic link in /usr/local/bin

if [ "$RELOC" == "1" ];then
      MYTARGET=`head -n 1 "$MYDIR/relocexecutable"`
      BINARYNAME=`echo $MYTARGET | sed "s#^.*/##"`
      APPSYMLINK="/usr/local/bin/$BINARYNAME"


      USESYMLINK=yes
      rm -f "$APPSYMLINK"
#      ln -s "$FOLDER/$MYTARGET" "$APPSYMLINK"
# Update: replace symlink with script
sc="#!/bin/bash
cd \"$FOLDER/tkhearts\"
\"$FOLDER/$MYTARGET\" \"\$@\"

"
echo "$sc" > "$APPSYMLINK"
chmod 755 "$APPSYMLINK"



echo ---------------------
echo   "$FOLDER/$MYFILE" "$APPSYMLINK"
echo ---------------------
else
      MYFILE=`head -n 1 "$MYDIR/wxbmenue.rc"`
      BINARYNAME=`echo $MYFILE | sed "s#^.*/##"`
      APPSYMLINK="/usr/local/bin/$BINARYNAME"
      USESYMLINK=yes
      rm -f "$APPSYMLINK"
#      ln -s "$FOLDER/$MYFILE" "$APPSYMLINK"
# Update: replace symlink with script
sc="#!/bin/bash
cd \"$FOLDER/tkhearts\"
\"$FOLDER/tkhearts/$BINARYNAME\" \"\$@\"

"
echo "$sc" > "$APPSYMLINK"
chmod 755 "$APPSYMLINK"

fi

sync

########################################
# generate menue-entries for the Windowmanagers

if [ -f "$MYDIR/wxbmenue.rc" ];then

MYFILE=`head -n 1 "$MYDIR/wxbmenue.rc"`
rm -f /tmp/mrc1

fi

if [ -f "$MYFILE" ]; then


#############################
## generate Entry for wxB-menue



  FILE=$MYFILE
  echo "<?xml version=\"1.0\"?>" >/tmp/mrc1
  echo "<RootMenu>" >>/tmp/mrc1
  echo "<Menu label=\"DotPups\" icon=\"nothing.xpm\">" >>/tmp/mrc1

  ### check, if there already is a "DotPups"-submenue
  MENUEXISTED=1
  MYGREP=`grep "<Menu label=\"DotPups\"" ~/.myownmenuerc`
  if [ "$MYGREP" = "" ];then
    MENUEXISTED=0
  fi
  ### delete old entries
  rm -f /tmp/mrc0
  cat ~/.myownmenuerc |sed "s#^<Program.label=.tkhearts..*$##g" |while read a ;
  do if [ "$a" ];then echo $a>>/tmp/mrc0;fi;done

  if [ "$MYFILE" ];then 
    echo "<Program label=\"tkhearts\" icon=\"/usr/share/icons/tkhearts.xpm\">$FILE</Program>" >>/tmp/mrc1
  fi
  if [ "$MENUEXISTED" = "0" ];then
    echo "</Menu>" >>/tmp/mrc1
  fi

  cat /tmp/mrc0 |sed "s/<.xml.*$//" |sed "s/<RootMenu>.*$//"  |sed "s/<.RootMenu>.*$//" |sed "s/<Menu.label=.DotPups.*$//" |sed "s/^$//g" |while read a ;
  do if [ "$a" ];then echo $a>>/tmp/mrc1;fi;done

  echo "</RootMenu>" >>/tmp/mrc1
  cp  ~/.myownmenuerc  ~/.myownmenuerc.bak
  mv /tmp/mrc1  ~/.myownmenuerc
  if [ "$MYFILE" ];then 
      #xmessage -nearmouse "added entry to wxB-Menue. You must restart the menue to see it."
INSTALLEDMENUES1="wxB-Menue"
  fi
  rm -f /tmp/mrc0


  MYFILE=`head -n 1 "$MYDIR/wxbmenue.rc"`
  BINARYNAME=`echo $MYFILE | sed "s#^.*/##"`

#############################
## generate Entry for fvwm95
  ### register in the fvwm95 menu
  # entry is placed just above smm
  FVWM95RC="/root/.fvwm95rc"
  if [ -f $FVWM95RC ] ; then

  MYGREP=`grep "AddToMenu \"DotPups\"" $FVWM95RC`
  if [ "$MYGREP" = "" ];then

      cp -f $FVWM95RC /tmp/DOTfvwm95.pwizard_patched.backup
      EDITTEXT="s#\(Popup.UtilityApps$\)#\1\n+ \"DotPups%package.xpm%\" Popup DotPups#"
      sed -e "$EDITTEXT" $FVWM95RC >/tmp/patchedinstall.tmp
      sleep 1
      echo "DestroyMenu \"DotPups\"" >>/tmp/patchedinstall.tmp
      echo "AddToMenu \"DotPups\"" >>/tmp/patchedinstall.tmp
      mv -f /tmp/patchedinstall.tmp $FVWM95RC
  #    sleep 1
  fi

    # this option is used to prevent the entry from going in more than once
    grep "$MYFILE" $FVWM95RC
    if [ $? -ne 0 ] ;then
      cp -f $FVWM95RC /tmp/DOTfvwm95.pwizard_patched.backup
      EDITTEXT="s#^\(AddToMenu.\"DotPups\".*$\)#\1\n+ \"$BINARYNAME%/usr/share/icons/tkhearts.xpm%\" Exec exec $MYFILE#"
      sed -e "$EDITTEXT" $FVWM95RC >/tmp/patchedinstall.tmp
      mv -f /tmp/patchedinstall.tmp $FVWM95RC
   #   sleep 1
INSTALLEDMENUES2="Fvwm95"

    fi
  fi 

#############################
## generate Entry for icewm
  ### register in the icewm menu
  # entered just above smm
  ICEWMMENU="/root/.icewm/menu"

  if [ -f $ICEWMMENU ] ; then
  MYGREP=`grep "menu \"DotPups\"" $ICEWMMENU`
  if [ "$MYGREP" = "" ];then
    echo "menu \"DotPups\" dotpups {" >>$ICEWMMENU
    echo "}" >>$ICEWMMENU
  fi

    # this option is used to prevent the entry from going in more than once
    grep "$MYFILE" $ICEWMMENU
    if [ $? -ne 0 ] ;then
      cp -f $ICEWMMENU /tmp/icewmmenu.pwizard.backup
      EDITTEXT="s#^\(menu.\"DotPups\".dotpups.{\)#\1\n\tprog \"$BINARYNAME\" \"/usr/share/icons/tkhearts.xpm\" $MYFILE#"
      sed -e "$EDITTEXT" $ICEWMMENU >/tmp/patchedinstall.tmp
      mv -f /tmp/patchedinstall.tmp $ICEWMMENU
INSTALLEDMENUES3="IceWM"
    fi
  fi

#############################
## generate Entry for jwm
  ### register in the jwm menu
  # entry is just above smm
  JWMRC="/root/.jwmrc"

  if [ -f $JWMRC ] ; then  

  MYGREP=`grep "<Menu label=\"DotPups\"" $JWMRC`
  if [ "$MYGREP" = "" ];then

      cp -f $JWMRC /tmp/DOTjwm.pwizard_patched.backup
      EDITTEXT="s#\(<RootMenu.label.*$\)#\1\n<Menu label=\"DotPups\" icon=\"package.xpm\">\n</Menu>#"
      sed -e "$EDITTEXT" $JWMRC >/tmp/patchedinstall.tmp
      sleep 1
      mv -f /tmp/patchedinstall.tmp $JWMRC
      sleep 1
  fi
    # this option is used to prevent the entry from going in more than once
    grep "$MYFILE" $JWMRC
    if [ $? -ne 0 ] ;then
      cp -f $JWMRC /tmp/DOTjwm.pwizard_patched.backup
      EDITTEXT="s#^\(<Menu.label=\"DotPups\".*$\)#\1\n<Program label=\"$BINARYNAME\" icon=\"/usr/share/icons/tkhearts.xpm\">$MYFILE</Program>#"
      sed -e "$EDITTEXT" $JWMRC >/tmp/patchedinstall.tmp
      mv -f /tmp/patchedinstall.tmp $JWMRC
      sleep 1
INSTALLEDMENUES4="JWM"
    fi
  fi 


    INSTALLEDMENUESCHECK=$INSTALLEDMENUES1$INSTALLEDMENUES2$INSTALLEDMENUES3$INSTALLEDMENUES4
    INSTALLEDMENUESALL="\n$INSTALLEDMENUES1\n$INSTALLEDMENUES2\n$INSTALLEDMENUES3\n$INSTALLEDMENUES4\n"






#############################

fi # //if [ -f "$MYFILE" ] then



echo ---------------------
echo "menufunctions were passed, now register pupget"
echo --------------------

## delete the application-folder, if it is empty

    rmdir "$FOLDER/tkhearts"


  #### test if PCCC is available (Puppy-Linux)
  if [ ! -f "/root/.packages/packages.txt" ];then
      rm -f "$MYDIR/checkspace.pb"
      rm -f "$MYDIR/checkspace2.pb"
      #### finally open the new folder in Rox and display "goodbye" (Systems without PCCC)
      rox "$FOLDER/tkhearts"   
      $DIALOG --title "info" --msgbox "Finished installation." 6 60
      
      exit 0
  fi

  #### register to PCCC
#mkdir /root/.dotpupwizard
#echo "$FOLDER/tkhearts" > "/root/.dotpupwizard/tkhearts.dir"

      #### register to PCCC
      #### avoid double entries in PCCC
      MYGREP=`grep "tkhearts" /root/.packages/alienpackages.txt`
      if [ "$MYGREP" = "" ];then
        echo \"tkhearts\" \"tkhearts\" on \"\" \\>>/root/.packages/alienpackages.txt
      fi

      #### Register Keyword to PCCC , only if it has Menueentries
      if [ -f "$MYFILE" ]; then
        echo tkhearts>/root/.packages/tkhearts.keyword
      fi
      #### Register filelist to PCCC
      rm -f /root/.packages/tkhearts.files
      tar -tjf "$MYDIR/tkhearts.tbz" | while read a; do echo "$FOLDER/$a"|sed "s/^.*\/$//"|grep -v "^$" >>/root/.packages/tkhearts.files ; done
      cat "$MYDIR/config.files" |sed "s/^.*\/$//"|grep -v "^$" >> /root/.packages/tkhearts.files

      if [ "$USESYMLINK" = "yes" ];then
        echo "$APPSYMLINK"|sed "s/^.*\/$//"|grep -v "^$" >> /root/.packages/tkhearts.files
      fi
      #if [ "$RELOC" == "1" ];then
      if [ -f "$FOLDER/tkhearts/icon.xpm" ];then
        mkdir /usr/share/icons/
        rm -f "/usr/share/icons/tkhearts.xpm" 
        ln -s "$FOLDER/tkhearts/icon.xpm" "/usr/share/icons/tkhearts.xpm"   
        echo "/usr/share/icons/tkhearts.xpm" >> /root/.packages/tkhearts.files
      fi
        echo "$FOLDER/dotpupwizard.marker" >> /root/.packages/tkhearts.files
        #echo "/root/.dotpupwizard/tkhearts.dir" >> /root/.packages/tkhearts.files
      #fi
      ## V03 ##########################################################################################
      ###do the same with files from root.tbz and usr.tbz
      tar -tjf "$MYDIR/FILESYSTEM.tbz" | while read a; do echo "/$a"|sed "s/^.*\/$//"|grep -v "^$" >>/root/.packages/tkhearts.files ; done

    menutext=""
    if [ "$INSTALLEDMENUESCHECK" != ""  ];then
      menutext="Added Menue-entries to $INSTALLEDMENUESALL\nYou must restart them (except Icewm) to see them.\n\n" 
    fi
      #### finally open the new folder in Rox and display "goodbye" (Puppy: PCCC was used)
      if [ -d "$FOLDER/tkhearts" ] ; then
        rox "$FOLDER/tkhearts"
      fi

rm -f "$MYDIR/checkspace.pb"
rm -f "$MYDIR/checkspace2.pb"

      $DIALOG --title "info" --msgbox "Finished installation.\n$menutext\nTo Uninstall tkhearts, use the Pup-Get Package-Manager" 20 60
      

"$FOLDER/tkhearts/resource/postinstall.sh"
